  General purpose registru paskitrys:
AX Accumulator
BX Base register
CX Counting register
DX Data register
DS Data Segment register
ES Extra Segment register
SS Battery segment register
CS Code Segment register
BP Base Pointers register
SI Source Index register
DI Destiny Index register
SP Battery pointer register
IP Next Instruction Pointer register
F Flag register


      *AX(accumulator): naudojamas daugelyje darbu,pvz.matematinems,I/O operacijoms.
      *BX(base):naudojamas kaip bazinis arba rodykles registras. 
      *CX(counter): daznaisiai vartojamas skaiciavimui (pvz ciklu).
      *DX(data):naudojamas panasiai i DX registra.
: Segmetu registrai


        *CS (code segment)-siame registre saugomas programos kodas.CS netinkama modifikacja
            gali tureti atitinkamu pasekmiu-kompiuteris taps nevaldomas.
        *DS (data segment)-kaip ir CS,tai bkolas atminties,bet james suagomas
            ne programos kodas,o duomenys.
        *ES (extra segment)-kaip ir DS,bet dazniausiai naudojamas video 
            operacijoms.
        *SS (stack segment)-jame CPU laiko griztamuosius proceduru adresus.

      :Kiti


       *SI (source index) - daznai nuadojamas koncujkcijoje su bloku perkelimo
           instrukcijomis.Tai rodykle,daznaisuiai esanti DS,kuri skaito 
           tiesiai per procesoriu.
       *DI (destination indxe) - kita rodykle,dazniausiai esanti ES,kuri raso
           tiesiai per CPU.
       *BP (base pointer) - dazniausiai naudojamas konjunkcijoje su SS.Sis 
           registras,priesingai SI ir DI,nera labai daznais naudojamas.
       *SP (stack pointer) - naudojamas su SS.Patartina naudoti tik tada,kada
           tvirtai numatote pasekmes.
  -----------------------------------------------------------------------
            Istrukcija          Sintakse          Pavyzdys
   -----------------------------------------------------------------------      

              MOV               MOV <a>,<b>       mov (move) ah,9 
                                                  ah suteiks reiksme lygia 9
                                                              
                                                  mov ah,cl
                                                   ah suteiks 
                                                   reiksme kuria turi cl

                                                  mov al,cx
                                                   negera sintakse,nes al yra
                                                   8 bitu registras,o cx - 16.

             INC               INC <a>            pvz. mov ax,1 ;ax=1
                                                       inc ax   ;ax=2 
                                                       inc ax   ;ax=3 
        
    
             DEC               DEC <a>               mov ax,5 ;ax=5
                                                      dec ax   ;ax=4
                
             ADD              ADD <a>,<b>      pvz. mov ax,1 ;ax=1
                                                      add ax,4 ;ax=1+4=5  
         

             INT              INT <nr>       interupt-pertraukimas.
                                             Tai naudojimasis  
                                             DOS arba BIOS teikiamomis 
                                             paslaugomis.
                                             pvz. int 21h - DOS standartinis 
                                             pertraukimas
                                                  int 10h - BIOS 
                                             video pertraukimas.Trakime 
                                             kokia nors dali programoje 
                                             parasyti gana sunku 
                                             (pvz. kursoriaus perkelima),tad
                                             tada ir naudojami pertraukimai.
  
            CMP              CMP <a> <b>     pvz. (compare)
                                             CMP al,bl palygina al su bl.
            JE               JE label        je x.Jeigu sukurtume labeli          
                                             x ir vykdydami koda padarytume 
                                             taip:

                                              mov ah,2
                                              mov cl,2
                                              cmp ah,cl
                                              je  x

                                            tada programa po je persoktu  
                                            prie x labelio.Je veikia jeigu 
                                            lygu.Atitinkamai jeigu is pirmo 
                                            ah ir cl reiksmes nebutu lygios,
                                            programa nepersoktu prie labelio x.


          JZ               JZ label         pvz. mov ax,1
                                                 mov bx,0
                                                 and ax,bx ;ax konjunkcija bx
                                                 jz x

                                                Tas pats kas Je tik vykdoma jeigu 0 
        tiny        programa su viso koku,steku ir duomenimis 
                        turi tilpti i 64k segmenta.Tik sio is modelio programu
                        galima parengti *.com tipo failus.

            small       Programos kodui skiriama 64k,bei 
                        tiek pat duomenims ir stekui.
           
            medium      kodas gali buti didenis uz 64k (iki 1M),
                        bet duomenys negali.Daznaiusiai naudojamas,kai 
                        sudetingi algoritmai taikomi paprastoms duomenu 
                        strukturoms apdotori.

  
           compact      Atvirksciai medium-kodas gali 
                        buti >64k,bet duomenys ne.
 
           large        kodas ir duomenys gali buti 
                        didesni uz 64k,bet mastvai negali.

           huge         bet kokios strukturos gali buti didesnes uz 64k.
   -------------------------------------------------------------------------------------   
       Istrukcija                   Sintakse                   Pavyzdziai     
    -------------------------------------------------------------------------------------                   

        push                         push<reg>                  push ax
                                                                  padeda ax i steka                                                                              push ah
                                                                  padeda ah i steka
        
        pop                          pop<reg>                   pop ax
                                                                    grazina ax  is steko
                                                                pop ah
                                                                    grazina ah is steko
 

        jmp                          jmp label                    jmp x
                                                                  persoka prie x labelio
 
        jg                          jg label                     kaip ir JE tik sis vykdomas jeigu didesnis 


        mul                          mul <reg>                   mov ax,10 ;ax=10          
                                                                 mov bx,5  ;ax=5 
                                                                 mul bx    ;bx=50
                                                                 (mul -daugyba)

        div                          div <reg>                   mov ax,5 ;ax=5
                                                                 mov bh,2 ;bh=2
                                                                 div bh   ;al=2,ah=5
                                                                 (div - dalyba)

        loop                          loop <label>               loop-ciklu skaiciaus nustatymas
                                                                 panasiai,kaip for paskalyje.
                                                                 pvz mov cx,10h ;kiek kartu
                                                                                ;10 hex=16
                                                                   loop @label                 
                                                                    
                                                                  Tai pakaros @lebel 16 kartu 

        cbw                             cbw                        konvertuoja 8 bitu registra (pvz.ah) i 16 (pvz ax)                                                                            
       loadsb                           loadsb                     padeda baita
       loadsw                           loadsw                     padeda word'a (2 baitai)
       stosb                            stosb                      paima baita
       stosw                            stosw                      paima word'a


Stai keletas nauju ASM istrukciju:


LEA (load effective address).Naudojimas LEA <a> <b> Si istrukcija pakrauna ta adresa kuriame yra b i a.

AND.Logine operacija and.Pvz and ax,bx,
NOT.Logine operacija not.
XOR.Logine operacija xor.
PUSHA (push all). Ji padeda visus 16 bitu general purpose registrus i steka.
POPA  (pop all).Priesinga popa.
SUB  (substract).SUB <a> <b> Atima is a b ir rezultata padeda i a.

Komandu sistema
Intel architekturai budinga savybe  naudojama vienoda mnemonika visikai
skirtingoms komandoms.
d  krypties (destination) bitas, jis nurodo, ar operacijos kryptis yra i procesoriaus i
atminti, ar i atminties i procesoriu;
0  i procesoriaus registro i atminti
d =
1  i atminties i procesoriaus registr
w - ploio (width) bitas, jis nurodo operacijoje dalyvaujanio lauko ilgi;
0  operandas baitas
w =
1  operandas odis
mod lauko reikmes:
00  operandas r/m atmintyje (r/m = m), poslinkio nera;
mod = 01  operandas r/m atmintyje (r/m = m), vieno baito poslinkis;
10  operandas r/m atmintyje (r/m = m), dvieju baitu poslinkis;
11  operandas r/m registre (r/m = r);
bet.op.  betarpikas operandas.
v.b j.b
adr.j.b.  adreso jaunesnysis baitas
adr.v.b.  adreso vyresnysis baitas
sreg  segmento registras;
00  ES;
sreg = 01  CS;
10  SS;
11  DS;
portas  porto numeris diapazone 0  255
posl.j.b.  poslinkio jaunesnysis baitas
posl.v.b.  poslinkio vyresnysis baitas
seg.rer.j.b.  segmento registro jaunesnysis baitas
seg.reg.v.b.  segmento registro vyresnysis baitas

